/* Historie s oddělovacími komentáři: 07C_Arrays.jsh
############################## Příliš žluťoučký kůň úpěl ďábelské ódy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Výpis 7.0: Inicializace prostředí – definice pomocných metod a proměnných
********************************************************************/
/set start Start_07.jsh
/reset
/methods
/vars
/********************************************************************


/*
** Výpis 7.1: Deklarace a inicializace polí
********************************************************************/
int[] aInt;
String[] aString;
"aInt=" + aInt + ", aString=" + aString;
double[] aDouble = {0, 1.0, 2F};
Object[] aObject = {"nula", 1, 2.0, 6/2D, null, 0/0D};
"aDouble=" + aDouble + ", aObject=" + aObject;
println(
      "aDouble=" + Arrays.toString(aDouble)
  + "\naObject=" + Arrays.toString(aObject));
/********************************************************************


/*
** Výpis 7.2: Přiřazování hodnot polím
********************************************************************/
aInt = new int[8];
aInt = new int[] {0, 100, 200, 300};
println("aInt="+Arrays.toString(aInt));
aObject = new String[] { "nic víc" };
aDouble = aInt;
aString = new String[] {};
void printStringArray(String title, String[] stringArr)
{
    println(title + "=" + Arrays.toString(stringArr));
}
printStringArray("aObject", (String[])aObject);
String[] stringArray(int n) { return new String[n]; }
printStringArray("Vráceno metodou stringArray(int)", stringArray(2));
/********************************************************************


/*
** Výpis 7.3: Zjišťování délky pole
********************************************************************/
aInt.length
aString.length
stringArray(5).length
/********************************************************************


/*
** Výpis 7.4: Práce s prvky pole
********************************************************************/
aObject[0]
aObject[1]
(aString = stringArray(3))[2] = "Druhý";
aString[0] = "nultý";
aString[1] = "za mnou je " + aString[2];
printStringArray("Naplněný aString", aString);
/********************************************************************


/*
** Výpis 7.5: Obdélníková pole
********************************************************************/
String[][] a2String = new String[2][3];
a2String[0][1] = "nula-jedna";
a2String[1][2] = "jedna-dva";
println(arr2toString("Obdélníkové, tu tam inicializované", a2String));
a2String[0]
/********************************************************************


/*
** Výpis 7.6: Zubaté pole
********************************************************************/
String[][] demo() { //Ukázka postupné tvorby zubatého pole
    String[][] arr2 = new String[3][];
    arr2[0] = new String[]{"00", "01", "02"};
    arr2[1] = new String[2];
    return arr2;
} aObject = demo();
println(arr2toString("Zubaté, postupně vytvářené",
                     (Object[][])aObject));
a2String = new String[][]{ {"a", "b", "c"},
                           {},
                           {"w", "x", "y", "z"},
                         };
println(arr2toString("Zubaté, přímo inicializované", a2String));
/********************************************************************


/*
** Výpis 7.7: Proměnný počet argumentů
********************************************************************/
void variant(String title, int... args)
{
    int count = args.length;
    println(count + " argumentů pro " + title);
    println("Argumenty: " + Arrays.toString(args));
}
variant("Nic");
variant("Pět", 1, 2, 3, 4, 5);
/********************************************************************


/*
** Výpis 7.8: Emulace předávání argumentu odkazem
********************************************************************/
String passByReturn(String arg, boolean change)
{
    String result = change ? "Jiný objekt" : arg;
    return result;
}
{ String s="Původní string";
  s=passByReturn(s, false); println("Nezměněno: s=" + s);
  s=passByReturn(s, true ); println("Změněno:   s=" + s);
}
String passByReference(String[] arg, boolean change)
{
    arg[0] = change ? "Jiný objekt" : arg[0];
    return "Objekt " + (change ? "BYL" : "NEBYL") + " vyměněn";
}
{ String s="Původní string"; String[]as={s};
  println(passByReference(as, false) + " - " + Arrays.toString(as));
  println(passByReference(as, true ) + " - " + Arrays.toString(as));
}
/********************************************************************


/*
** Závěrečné uložení
********************************************************************/
/save -history 07H_Arrays.jsh
