//Soubor: 17D_Daughter.jsh

//################################## Příliš žluťoučký kůň úpěl ďábelské ódy

//#########################################################################



/*******************************************************************************

 * Instance třídy {@code Daughter} představují dcery.

 *

 * @author  Rudolf PECINOVSKÝ

 * @version 2020-Summer

 */

class Daughter extends Mother

{

    static { println("#####  Zavádím třídu Daughter  #####"); }

    { println("+++++  Inicializuji instanci třídy Daughter  +++++"); }



    /** Počet doposud vytvořených instancí.*/

    protected static int created = 0;



    /** Rodné číslo instance = pořadí jejího vzniku v rámci této třídy. */

    protected final String ID = "D"  + ++created + '-' + super.ID;





    /***************************************************************************

     * Konstruktor instance dcery.

     * Rodičovským podobjektem je virtuální instance třídy {@link Mother}.

     */

    public Daughter()

    {

        this(null);

    }



    /***************************************************************************

     * Konstruktor pro potomky, kteří potřebují něco provést

     * před zavoláním rodičovského konstruktoru.

     *

     * @param s Nepoužitý parametr

     */

    protected Daughter(String s)

    {

        super(intermezzo("=== Daughter volá rodičovský konstruktor"));

        constructorReport(this, Daughter.class);

    }



    /***************************************************************************

     * Vrátí textový podpis instance, tj. její řetězcovou reprezentaci.

     *

     * @return Textová reprezentace (podpis) dané instance

     */

    @Override

    public String toString()

    {

        return "Daughter_" + ID + "(" + super.toString() + ")";

    }



    { println("-----  Konec úvodní fáze inicializace Daughter  -----"); }

    static { println("-----  Třída Daughter zavedena  -----"); }

}







/**Výpis

**************************************************************************/

//#########################################################################

