//Soubor: 17S_d3_Granddaughter.jsh
//################################## Příliš žluťoučký kůň úpěl ďábelské ódy
//#########################################################################

/*******************************************************************************
 * Instance třídy {@code Granddaughter} představují vnučky.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
class Granddaughter extends Daughter
{
    static { println("#####  Zavádím třídu Granddaughter  #####"); }
    { println("+++++  Inicializuji instanci třídy Granddaughter  +++++"); }

    /** Počet doposud vytvořených instancí.*/
    protected static int created = 0;

    /** Rodné číslo instance = pořadí jejího vzniku v rámci této třídy. */
    protected final String ID = "G"  + ++created + '-' + super.ID;


    /***************************************************************************
     * Konstruktor instance vnučky.
     * Rodičovským podobjektem je virtuální instance třídy {@link Daughter}.
     */
    public Granddaughter()
    {
        this(null);
    }

    /***************************************************************************
     * Konstruktor pro potomky, kteří potřebují něco provést
     * před zavoláním rodičovského konstruktoru.
     *
     * @param s Nepoužitý parametr
     */
    protected Granddaughter(String s)
    {
        super(intermezzo("=== Granddaughter volá rodičovský konstruktor"));
        constructorReport(this, Granddaughter.class);
    }

    /***************************************************************************
     * Vrátí textový podpis instance, tj. její textovou reprezentaci.
     *
     * @return Textová reprezentace (podpis) dané instance
     */
    @Override
    public String toString()
    {
        return "Granddaughter_" + ID + "(" + super.toString() + ")";
    }

    { println("-----  Konec úvodní fáze inicializace Granddaughter  -----"); }
    static { println("-----  Třída Granddaughter zavedena  -----"); }
}



//#########################################################################
//save -history 17D_Granddaughter.jsh
