//Soubor: 19D_R_MDG_T.jsh

//################################## Příliš žluťoučký kůň úpěl ďábelské ódy



/env -class-path B62_Lib_Pkg.jar

import java.util.*;

import java.util.function.*;

import java.util.regex.*;

import eu.pedu.lib20s.canvas.*;

import eu.pedu.lib20s.geom.*;

import eu.pedu.lib20s.util.*;

import eu.pedu.lib20s.dbg.IndentingReporter;





/*******************************************************************************

 *******************************************************************************

 * Metody třídy Reports sloužící k demonstraci průběhu některých činností.

 *******************************************************************************

 ******************************************************************************/



    /***************************************************************************

     * Vypíše zprávu konstruktoru o typu konstruovaného objektu.

     */

    void constructorReport(Object instance, Class<?> cls)

    {

        Class<?> instanceCls = instance.getClass();

        boolean  topType     = instanceCls.equals(cls);

        String callingClass  = cls        .getSimpleName();

        String instanceClass = instanceCls.getSimpleName();

        String indent        = "                        "

                             .substring(0, callingClass.length()+2);

        System.out.println(callingClass + ": Vytvářím " + instance + "\n"+

                (topType ? ""

                         : indent + "jako rodičovský podobjekt objektu typu " +

                           instanceClass));

    }



    /***************************************************************************

     * Vytiskne argument na standardní výstup a vrátí jej jako funkční hodnotu.

     */

    String intermezzo(String input)

    {

        System.out.println(input);

        return input;

    }



    /***************************************************************************

     * Vytiskne podpis argumentu na standardní výstup.

     */

    void println(Object object)

    {

        System.out.println(object);

    }



    /***************************************************************************

     * Vypíše podpis prvního argumentu a zprávu zadanou v druhém.

     */

    void report(Object instance, String message)

    {

        System.out.println("\n  Instance: " + instance +

                           "\n  Zpráva:   " + message);

    }



    /***************************************************************************

     * Vypíše název třídy a spustí seznam metod.

     */

    <T extends Mother>

    void multireport(Class<T> cls, Runnable... methods)

    {

        System.out.println("Výpis ze třídy: " + cls.getSimpleName());

        Arrays.stream(methods).forEach(m -> m.run());

    }





/*******************************************************************************

 *******************************************************************************

* Třída matky.

 *******************************************************************************

 ******************************************************************************/



class Mother

{

    private static int created = 0;

    protected final String ID = "M"  + ++created;



    /***************************************************************************

     * Konstruktor instance matky.

     */

    public Mother()

    {

//        constructorReport(this, Mother.class);

    }



    /***************************************************************************

     * Virtuální metoda vracející identifikační kód instance.

     */

    public String getID()

    {

        return ID;

    }



    /***************************************************************************

     * Metoda deklarovaná v matce, nikde nepřebitá.

     */

//    @Override

    public void virtualM__()

    {

        report( this, "Verze matky  - " +

                      "M__ - Deklarovaná v matce, nikde nepřebitá");

    }





    /***************************************************************************

     * Metoda deklarovaná v matce, přebitá dcerou.

     */

//    @Override

    public void virtualMD_()

    {

        report( this, "Verze matky  - " +

                      "MD_ - Deklarovaná v matce, přebitá dcerou");

    }





    /***************************************************************************

     * Metoda deklarovaná v matce, přebitá až vnučkou.

     */

//    @Override

    public void virtualM_G()

    {

        report( this, "Verze matky  - " +

                      "M_G - Deklarovaná v matce, přebitá až vnučkou");

    }





    /***************************************************************************

     * Metoda deklarovaná v matce, přebitá dcerou i vnučkou.

     * Živá verze použitá v demonstračním programu.

     */

//    @Override

    public void virtualMDG()

    {

        report( this, "Verze matky  - " +

                      "MDG - Deklarovaná v matce, přebitá dcerou i vnučkou");

    }



    /***************************************************************************

     * Postupně zavolá všechny virtuální metody své instance.

     */

    public final void summaryMe()

    {

        System.out.println("Explicitní volání virtuálních metod třídy: " +

                            Mother.class.getSimpleName());

         this.virtualM__();      this.virtualMD_();

         this.virtualM_G();      this.virtualMDG();

    }



    /***************************************************************************

     * Vrátí textový podpis instance.

     */

    @Override

    public String toString()

    {

        return "Mother_" + ID + "(Object)";

    }

}





/*******************************************************************************

 *******************************************************************************

 * Třída dcery.

 *******************************************************************************

 ******************************************************************************/



class Daughter

     extends Mother

{

    private static int created = 0;

    protected final String ID = "D"  + ++created + '-' + super.ID;



    /***************************************************************************

     * Konstruktor instance dcery.

     */

    public Daughter()

    {

//        constructorReport(this, Daughter.class);

    }





    /***************************************************************************

     * Virtuální metoda vracející identifikační kód instance {@code this}.

     */

    @Override

    public String getID()

    {

        return ID;

    }



    /***************************************************************************

     * Metoda deklarovaná v matce, přebitá dcerou.

     */

    @Override

    public void virtualMD_()

    {

        report( this, "Verze dcery  - " +

                      "MD_ - Deklarovaná v matce, přebitá dcerou");

    }



    /***************************************************************************

     * Metoda deklarovaná v matce, přebitá dcerou i vnučkou.

     */

    @Override

    public void virtualMDG()

    {

        report( this, "Verze dcery  - " +

                      "MDG - Deklarovaná v matce, přebitá dcerou i vnučkou");

    }





    /***************************************************************************

     * Metoda deklarovaná v dceři, nikde nepřebitá.

     */

//    @Override

    public void virtual_D_()

    {

        report( this, "Verze dcery  - " +

                      "_D_ - Deklarovaná v dceři, nikde nepřebitá");

    }



    /***************************************************************************

     * Metoda deklarovaná v dceři, přebitá vnučkou.

     */

//    @Override

    public void virtual_DG()

    {

        report( this, "Verze dcery  - " +

                      "_DG - Deklarovaná v dceři, přebitá vnučkou");

    }





    /***************************************************************************

     * Metoda postupně zavolá všechny virtuální metody své instance.

     */

    public final void summaryDe()

    {

        System.out.println("Explicitní volání virtuálních metod třídy: " +

                           Daughter.class.getSimpleName());

         this.virtualM__();      this.virtualMD_();

         this.virtualM_G();      this.virtualMDG();

         this.virtual_D_();      this.virtual_DG ();

    }



    /***************************************************************************

     * Vrátí textový podpis instance.

     */

    @Override

    public String toString()

    {

        return "Daughter_" + ID + "(" + super.toString() + ")";

    }

}





/*******************************************************************************

 *******************************************************************************

 * Třída vnučky.

 *******************************************************************************

 ******************************************************************************/



class Granddaughter

     extends Daughter

{

    private static int created = 0;

    protected final String ID = "G"  + ++created + '-' + super.ID;



    /***************************************************************************

     * Konstruktor instance vnučky.

     */

    public Granddaughter()

    {

//        constructorReport(this, Granddaughter.class);

    }



    /***************************************************************************

     * Virtuální metoda vracející identifikační kód instance {@code this}.

     */

    @Override

    public String getID()

    {

        return ID;

    }



    /***************************************************************************

     * Metoda deklarovaná v matce, přebitá až vnučkou.

     */

    @Override

    public void virtualM_G()

    {

        report( this, "Verze vnučky  - " +

                      "M_G - Deklarovaná v matce, přebitá až vnučkou");

    }



    /***************************************************************************

     * Metoda deklarovaná v matce, přebitá dcerou i vnučkou.

     */

    @Override

    public void virtualMDG()

    {

        report( this, "Verze vnučky  - " +

                      "MDG - Deklarovaná v matce, přebitá dcerou i vnučkou");

    }



    /***************************************************************************

     * Metoda deklarovaná v dceři, přebitá vnučkou.

     */

    @Override

    public void virtual_DG()

    {

        report( this, "Verze vnučky  - " +

                      "_DG - Deklarovaná v dceři, přebitá vnučkou");

    }



    /***************************************************************************

     * Metoda deklarovaná ve vnučce, nikde nepřebitá.

     */

//    @Override

    public void virtual__G()

    {

        report( this, "Verze vnučky  - " +

                      "__G - Deklarovaná ve vnučce, nikde nepřebitá");

    }



    /***************************************************************************

     * Metoda postupně zavolá všechny virtuální metody své instance.

     */

    public final void summaryGe()

    {

        System.out.println("Explicitní volání virtuálních metod třídy: " +

                           Granddaughter.class.getSimpleName());

         this.virtualM__();      this.virtualMD_();

         this.virtualM_G();      this.virtualMDG();

         this.virtual_D_();      this.virtual_DG ();

         this.virtual__G();

    }



    /***************************************************************************

     * Vrátí textový podpis instance, tj. její řetězcovou reprezentaci.

     */

    @Override

    public String toString()

    {

        return "Granddaughter_" + ID + "(" + super.toString() + ")";

    }

}





/*******************************************************************************

 *******************************************************************************

 * testovací / demonstrační třída.

 *******************************************************************************

 ******************************************************************************/



class TestVirtual

{

    private static IndentingReporter IR;



    /***************************************************************************

     * Report objektů vydávajících se za matku.

     */

    private static void motherReport(String subject, Mother mother)

    {

        IR.reportStart(subject + " vydávající se za matku");

        mother.summaryMe();

        IR.reportEnd();

    }





    /***************************************************************************

     * Report objektů vydávajících se za dceru.

     */

    private static void daughterReport(String subject, Daughter daughter)

    {

        IR.reportStart(subject + " vydávající se za dceru");

        daughter.summaryDe();

        IR.reportEnd();

    }





    /***************************************************************************

     * Report objektů vydávajících se za vnučku.

     */

    private static void granddaughterReport(String subject,

                                            Granddaughter granddaughter)

    {

        IR.reportStart(subject + " vydávající se za vnučku");

        granddaughter.summaryGe();

        IR.reportEnd();

    }





    /***************************************************************************

     * Testuje volání virtuálních metod objektů v přípravku.

     */

    public static void testReportByRole()

    {

        Mother        mother        = new Mother();

        Daughter      daughter      = new Daughter();

        Granddaughter granddaughter = new Granddaughter();



        IR.reportStart("Reporty objektů vydávajících se za matku"); {

            motherReport("Matka",  mother);

            motherReport("Dcera",  daughter);

            motherReport("Vnučka", granddaughter);

        }IR.reportEnd();

        IR.reportStart("Reporty objektů vydávajících se za dceru"); {

            daughterReport("Dcera",  daughter);

            daughterReport("Vnučka", granddaughter);

        }IR.reportEnd();

        IR.reportStart("Reporty objektů vydávajících se za vnučku");{

            granddaughterReport("Vnučka", granddaughter);

        }IR.reportEnd();

    }





    /***************************************************************************

     * Testuje volání virtuálních metod objektů v přípravku.

     */

    public static void testReportByMother()

    {

        Mother        mother        = new Mother();

        Daughter      daughter      = new Daughter();

        Granddaughter granddaughter = new Granddaughter();



        IR.reportStart("Reporty instance matky"); {

            motherReport("Matka",  mother);

        }IR.reportEnd();

        IR.reportStart("Reporty instance dcery"); {

            motherReport  ("Dcera",  daughter);

            daughterReport("Dcera",  daughter);

        }IR.reportEnd();

        IR.reportStart("Reporty instance vnučky");{

            motherReport       ("Vnučka", granddaughter);

            daughterReport     ("Vnučka", granddaughter);

            granddaughterReport("Vnučka", granddaughter);

        }IR.reportEnd();

    }





    /***************************************************************************

     * Metoda spouštějící celou aplikaci.

     */

    public static void main(String[] args)

    {

        IR = IndentingReporter.getSystemReporter();

        testReportByRole();

        System.out.println("################################################");

        testReportByMother();

    }

}



void test19MDG() {

   TestVirtual.main(new String[] {});

}



/**Výpis

**************************************************************************/

//#########################################################################

//save -history 19H_R_MDG_T.jsh

