/* Historie s oddělovacími komentáři: 23C_TypeArguments.jsh
############################## Příliš žluťoučký kůň úpěl ďábelské ódy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Výpis 23.0: Inicializace
********************************************************************/
/set start Start_17.jsh
/reset
/********************************************************************


/*
** Výpis 23.1: Definice tříd ListTest1 a ListTest2
********************************************************************/
class ListTest1 <E, L extends List<E>> { /* Tělo třídy */ }
class ListTest2 <L extends List<E>, E> { /* Tělo třídy */ }
/********************************************************************


/*
** Výpis 23.2: Definice tříd ParentChild a ChildParent
********************************************************************/
class ParentChild<Parent, Child extends Parent> { /* Tělo třídy. */ }
class ChildParent<Child extends Parent, Parent> { /* Tělo třídy. */ }
/********************************************************************


/*
** Výpis 23.3: Definice třídy a zpětně přeložené verze jejího překladu
********************************************************************/
/*Definice:
B62_Lib_Pkg\src\eu\pedu\b62_j14\c23_typearguments\Erasure_Before_After.java
*/
/********************************************************************


/*
** Výpis 23.4: Definice třídy UpperStringList
********************************************************************/
/*Definice:
B62_Lib_Pkg\src\eu\pedu\b62_j14\c23_typearguments\UpperStringList.java
*/
/********************************************************************


/*
** Výpis 23.5: Definice přemosťovací metody
********************************************************************/
/*Definice:
Překladačem přidaná přemosťovací metoda
*/
/********************************************************************


/*
** Výpis 23.6: Definice třídy Prohibited
********************************************************************/
class Prohibited<T>
{
    T t = new T();
}
/********************************************************************


/*
** Výpis 23.7: Definice polí instancí třídy ArrayList
********************************************************************/
ArrayList<String>[] listS = new ArrayList<>[5];
ArrayList<String>[] listS = new ArrayList<String>[5];
ArrayList[] listR = new ArrayList[5];
ArrayList<String>[] listS = new ArrayList[5];
listS[0] = new ArrayList<String>();
listS[1] = new ArrayList<Integer>();
/********************************************************************


/*
** Výpis 23.8: Definice metody používající proměnný počet argumentů
 *             parametrizovaného typu
********************************************************************/
public void mtd(List<String>... lists){}
/********************************************************************


/*
** Výpis 23.9: Možné nekorektní operace
********************************************************************/
@SafeVarargs void m(List<String>... stringLists) {  // Not actually safe!
    Object[] array = stringLists;
    List<Integer> tmpList = Arrays.asList(42);
    array[0] = tmpList; // Semantically invalid, but compiles without warnings
    String s = stringLists[0].get(0); // Oh no, ClassCastException at runtime!
}
/********************************************************************


/*
** Výpis 23.10: Vytvoření pole typového parametru
********************************************************************/
@SafeVarargs <E> E[] arrayOf(E... array) { return array; }
var aint = arrayOf(1, 3, 5, 7, 11);
var astr = arrayOf("Raz", "Dva", "Tři");
Object[] oo = aint;
oo[0] = "NULA";
/********************************************************************


/*
** Výpis 23.11: Definice generické třídy Crate12
********************************************************************/
public class Crate12<T1, T2>
{
    T1 t1;
    T2 t2;

    public T1 get1() { return t1; }
    public T1 get2() { return t1; }

    public void set(T1 o)  { t1 = o; }
    public void set(T2 o)  { t2 = o; }
}
/********************************************************************


/*
** Výpis 23.12: Definice generické třídy Crate11
********************************************************************/
public class Crate11<T>
{
    T t1, t2;

    public boolean equals(T t)
    {
        return (t1.equals(t) && t2.equals(t));
    }
}
/********************************************************************


/*
** Výpis 23.13: Definice tříd Parent, Child a IntervalD
********************************************************************/
public class IntervalD<T extends Comparable<T>> {
    public IntervalD(T lower, T upper) {}
}
class Parent implements Comparable<Parent> {
    public int compareTo(Parent r)  { return 0; }
}
class Child extends Parent {  //implements Comparable<Parent>
    public int compareTo( Parent r )  { return 0; }
}
IntervalD<Parent> icp = new IntervalD<>(new Parent(), new Child());
IntervalD<Child> icc = new IntervalD<>(new Child(), new Child());
/********************************************************************


/*
** Výpis 23.14: Upravená (ale špatně) definice třídy Child
********************************************************************/
class Child extends Parent implements Comparable<Child> {
    public int compareTo( Parent r )  { return 0; }
}
/********************************************************************


/*
** Výpis 23.15: Definice třídy Interval<T extends Comparable<? super T>>
********************************************************************/
/********************************************************************


/*
** Závěrečné uložení
********************************************************************/
/save -history 23H_TypeArguments.jsh
